﻿/*  ----------------------------------------------------------------------------
 *  Microsoft Public License (http://www.microsoft.com/opensource/licenses.mspx#Ms-PL)
 *  
 *  ----------------------------------------------------------------------------
 *  DynamicAspect
 *  ----------------------------------------------------------------------------
 *  File:       WeaverExtensionTest.cs
 *  Author:     NiceWk (n9walker@hotmail.com)
 *  ----------------------------------------------------------------------------
 */

using Bizall.Dynamic.Aspect;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using DynamicAspectTester.Mocks;

namespace DynamicAspectTester
{
    
    
    /// <summary>
    ///This is a test class for WeaverExtensionTest and is intended
    ///to contain all WeaverExtensionTest Unit Tests
    ///</summary>
    [TestClass()]
    public class WeaverExtensionTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for AsDynamic
        ///</summary>
        public void AsDynamicTestHelper<T>(T source)
            where T : class
        {
            WeavableObject<T> actual = WeaverExtension.AsDynamic<T>(source);
            var expected = source.AsDynamic<T>();
            Assert.AreEqual( actual.GetType() , expected.GetType());

        }

        [TestMethod()]
        public void AsDynamicTest()
        {
            AsDynamicTestHelper<TargetClass>(new TargetClass());
        }
    }
}